﻿namespace TabsStudioPriorityGroup
{
    class OptionsStorage
    {
        public OptionsStorage(string addinSettingsDirectory_)
        {
            addinSettingsDirectory = addinSettingsDirectory_;
        }

        public Options Load()
        {
            try
            {
                using (System.IO.FileStream stream =
                    new System.IO.FileStream(GetStoragePath(), System.IO.FileMode.Open,
                        System.IO.FileAccess.Read, System.IO.FileShare.Read))
                {
                    System.Xml.Serialization.XmlSerializer serializer =
                        new System.Xml.Serialization.XmlSerializer(typeof(Options));
                    return serializer.Deserialize(stream) as Options;
                }
            }
            catch (System.Exception)
            {
            }

            try
            {
                using (System.IO.FileStream stream =
                    new System.IO.FileStream(GetOldStoragePath(), System.IO.FileMode.Open,
                        System.IO.FileAccess.Read, System.IO.FileShare.Read))
                {
                    System.Xml.Serialization.XmlSerializer serializer =
                        new System.Xml.Serialization.XmlSerializer(typeof(Options));
                    Options result = serializer.Deserialize(stream) as Options;
                    Save(result);
                    return result;
                }
            }
            catch (System.Exception)
            {
            }

            return new Options();
        }

        public void Save(Options options)
        {
            try
            {
                using (System.IO.FileStream stream =
                    new System.IO.FileStream(GetStoragePath(), System.IO.FileMode.Create))
                {
                    System.Xml.Serialization.XmlSerializer serializer =
                        new System.Xml.Serialization.XmlSerializer(typeof(Options));
                    serializer.Serialize(stream, options);
                }
            }
            catch (System.Exception)
            {
            }
        }

        private string GetOldStoragePath()
        {
            return System.IO.Path.ChangeExtension(System.Reflection.Assembly.GetExecutingAssembly().Location, "tss");
        }

        private string GetStoragePath()
        {
            return System.IO.Path.Combine(addinSettingsDirectory, "PriorityGroup.tss");
        }

        private string addinSettingsDirectory;
    }
}
